function [ output, distance_between_first_positive_and_first_negative_edge ] = electric_failure_check( vector )
%Returns true if the vector only contains 1 trig signal.
%   Detailed explanation goes here
    output=false;
    vector=vector./max(abs(vector));
    trig_value_up=0.7;
    trig_value_down=0.4;
    mask=zeros(1, length(vector));
    mask(1)=0;
    for i=2:length(vector),
        if mask(i-1)==0,            
            if vector(i)>=trig_value_up,
                mask(i)=1;
            else
                mask(i)=0;
            end
        else
            if vector(i)<=trig_value_down,
                mask(i)=0;
            else
                mask(i)=1;
            end
        end
    end
    edge=zeros(1, length(vector));
    distance_between_first_positive_and_first_negative_edge=-1;
    index_edge1=-1;
    for i=2:length(mask),
        if mask(i)~=mask(i-1)==1,            
            edge(i)=1;
            if index_edge1==-1,
                index_edge1=i;
            elseif distance_between_first_positive_and_first_negative_edge==-1,
                distance_between_first_positive_and_first_negative_edge=i-index_edge1;
            end
        end
    end
    %disp(sum(edge))
    %disp('first pulse width:')
    %disp(distance_between_first_positive_and_first_negative_edge)
    %%%%%%%Printer antall trigpulse:
    if sum(edge)<=2 && distance_between_first_positive_and_first_negative_edge<=6,
        %disp('electric failure')
        output=true;
    end
end

