function [ factor_x1, factor_y ] = damping_factor_freq( X1, Y, figure_nr)
%UNTITLED returns differense between dft amplitude at 600 KHz and 1MHz for x1 and y 
%   Detailed explanation goes here

    factor_x1=zeros(size(X1,1),1);
    factor_y=zeros(size(X1,1),1);
    for k=1:size(X1,1),
        x1=X1(k,:);
        y=Y(k,:);



        len_x1=length(x1);
        len_y=length(y);
        y_pad=zeros(1,len_y+2*len_x1-1);
        y_pad(len_x1:len_x1+len_y-1)=y;
        err1=zeros(1,len_y+len_x1-1);


        for i=1:(len_y+len_x1-1),
            err1(i)=sum((x1-y_pad(i:i+len_x1-1)).^2);
        end


        [~,i]=min(err1);


        index=i-len_x1;

        if (index+1)<1,
            y_cmp=y(1:end+index);
            x_cmp=x1(-index+1:end);
        else
            y_cmp=y(index+1:end);
            x_cmp=x1(1:end-index);
        end



        Fs = 14290000;
        N=length(x_cmp);
        if N>20,
            freq_step=14290000/(2*floor(N/2+1));
            freq_axis=0:freq_step:(14290000/2)-freq_step;
            xdft = fft(x_cmp(1:N));
            xdft = xdft(1:floor(N/2+1));
            psdx = (1/(Fs*N)).*abs(xdft);%.^2;
            psdx(2:end-1) = 2*psdx(2:end-1);


            ydft = fft(y_cmp(1:N));
            ydft = ydft(1:floor(N/2+1));
            psdy = (1/(Fs*N)).*abs(ydft);%.^2;
            psdy(2:end-1) = 2*psdy(2:end-1);

            index_500K=saturation1(floor(500000/freq_step), 1, length(psdx));
            index_700K=saturation1(floor(700000/freq_step), 1, length(psdx));
            index_900K=saturation1(floor(900000/freq_step), 1, length(psdx));
            index_1200K=saturation1(floor(1200000/freq_step), 1, length(psdx));
                
            
            ampx_1M=max(psdx(index_900K:index_1200K));
            ampx_600K=max(psdx(index_500K:index_700K));
            ampy_1M=max(psdy(index_900K:index_1200K));
            ampy_600K=max(psdy(index_500K:index_700K));
            factor_x1(k)=ampx_1M/ampx_600K;
            factor_y(k)=ampy_1M/ampy_600K;
              
              if nargin > 2
                figure(figure_nr)
                subplot(1,2,1)
                hold off
                plot(freq_axis,psdx)
                hold on
                plot(4000000,ampx_1M,'o')
                plot(4000000,ampx_600K,'*')
                subplot(1,2,2)
                hold off
                plot(freq_axis,psdy)
                hold on
                plot(4000000,ampy_1M,'o')
                plot(4000000,ampy_600K,'*')
                pause(0.01)
              end
        else
            disp('not_valid')
        end

    end
    
end

