function [ index_start, index_end ] = echoStartAndEndIndex(vectorinn, startindex)
%echoStartAndEndIndex: [ index_start, index_end ] = echoStartAndEndIndex(vectorinn, startindex)
% returns the indexes of start and end of echo.
% Startindex needs to be somewhere withinn the echo.
% Returns -1 if error
%   Detailed explanation goes here
%   
% 
    
    vector=vectorinn;
    factor=find_energy_threshold(vector);
    energy_threshold=factor*max(vectorinn);
    indexup=startindex+1;
    indexdown=startindex-1;
    if indexup>size(vector,2),
        indexup=size(vector,2);
    end
    if indexdown<1,
        indexdown=1;
    end
    signal_end_found=false;
    signal_start_found=false;
    index_end=0;
    index_start=0;
    while ~(signal_end_found && signal_start_found),
%         hold off
%         plot(vectorinn)
%         hold on
%         plot(indexup,vectorinn(indexup), 'ro')
%         plot(indexdown,vectorinn(indexdown), 'ro')
%         k=waitforbuttonpress;
        if vector(indexup)<energy_threshold,
            signal_end_found=true;
            index_end=indexup;
        end
        if vector(indexdown)<energy_threshold,
            signal_start_found=true;
            index_start=indexdown;
        end
        if indexup==size(vector,2) && indexdown==1,
            output=[0,0];
            return
        end
        if ~signal_end_found,
            indexup=indexup+1;
        end
        if ~signal_start_found,
            indexdown=indexdown-1;
        end
        if indexup>size(vector,2),
            indexup=size(vector,2);
            signal_end_found=true;
            index_end=indexup;
        end
        if indexdown<1,
            indexdown=1;
            signal_start_found=true;
            index_start=indexdown;
        end
    end
   
 

end

