clear all
Fs = 14290000;
%Filenames of the rawdata files to read from
%read_filename={'vann_us_temp_cond_03022014'};
% read_filename={'adblue321_all_11022014'};
% light_sensor_calibration={'11022014calib_light_sensor'};
% read_filename={'adblue158_all_12022014'};
% light_sensor_calibration={'12022014calib_light_sensor'};
% read_filename={'diesel_all_14022014'};
% light_sensor_calibration={'14022014calib_light_sensor'}; 



small_file=true;
write_to_file=true;
figure_index=1;

% read_filename={ 'adblue321_all_11022014', ...
%                 'adblue158_all_12022014', ...
%                 'diesel_all_14022014', ...
%                 'glycol100_us_temp_cond_14032014', ...
%                 'glycol50_us_temp_cond_17032014', ...
%                 'water_us_temp_cond_19032014'};
read_filename={ ...
%                 '2000adblue321_all_11022014', ...
%                 '2000adblue158_all_12022014', ...
                '2000diesel_all_14022014', ...
                '2000glycol100_us_temp_cond_14032014', ...
                '2000glycol50_us_temp_cond_17032014', ...
                '2000water_us_temp_cond_19032014'};
fluid_types={ ...
%              'adblue321', ...
%              'adblue158', ...
             'diesel', ...
             'glycol100', ...
             'glycol50', ...
             'water'};
light_sensor_calibration={ ...
%                             '11022014calib_light_sensor', ...
%                             '12022014calib_light_sensor', ...
%                             '13022014calib_light_sensor', ...
                            '14022014calib_light_sensor', ...
                            '11022014calib_light_sensor', ...
                            '11022014calib_light_sensor', ...
                            '11022014calib_light_sensor'};
                            


number_of_files_to_read=length(read_filename);           
example=[];
for k=1:number_of_files_to_read,           
	filename=read_filename{k};
    fluid_type=fluid_types{k};
    disp(filename)
    if small_file,
        filename_arduino=['small_', filename, '_light_cond_temp', '.txt'];
        filename_us=['small_', filename, '_us', '.txt'];
        v=labinput(['smallfiles\',filename_us],1);
        arduino=dlmread(['smallfiles\',filename_arduino]);
    else
        filename_arduino=[filename, '_light_cond_temp', '.txt'];
        filename_us=[filename, '_us', '.txt'];    
        v=labinput(['labdata\',filename_us],1);
        arduino=dlmread(['labdata\',filename_arduino]);
    end
%     v=labinput(['labdata\',filename_us],1);
%     arduino=dlmread(['labdata\',filename_arduino]);
    temperature=arduino(:,9);
    %%%Remove outlayers%%%
    temperature=volt_to_temp(temperature);
    v=v(temperature>-40,:);
    arduino=arduino(temperature>-40,:);
    %%%Remove outlayers done%%%
    temperature=arduino(:,9);
    conductivity=arduino(:,[6,7,8]);
    light=arduino(:,[1,2,3,4,5]);
    light_calibration=dlmread(['lyssensordata\',light_sensor_calibration{k},'.txt']);
    %legend('red (624 nm)','yellow/orange (605 nm)','yellow (589 nm)','green (573 nm)','blue/green (505 nm)','blue (466 nm)');
    
    

    
    number_of_measurements=size(v,1);
    piezo_echo_peaks=zeros(number_of_measurements, 4);
    piezo_echo_peaks_index=zeros(number_of_measurements, 4);
    for i=1:number_of_measurements,
%        hold off
%        plot(v(i,:))
%        plot(signal_energy_window(v(i,:), 28))
%        energy_startup_noise=signal_energy_window(v(i,120:500), 28);
       
       [a_peak1, i_peak1]=max(v(i,121:200));
       [a_peak2, i_peak2]=max(v(i,201:280));
       [a_peak3, i_peak3]=max(v(i,281:360));
       [a_peak4, i_peak4]=max(v(i,361:440));
%        [a_peak1, i_peak1]=max(energy_startup_noise(21:100));
%        [a_peak2, i_peak2]=max(energy_startup_noise(101:175));
%        [a_peak3, i_peak3]=max(energy_startup_noise(176:250));
%        [a_peak4, i_peak4]=max(energy_startup_noise(250:350));
%        hold on
%        plot(i_peak1+120, a_peak1, 'o')
%        plot(i_peak2+200, a_peak2, 'o')
%        plot(i_peak3+280, a_peak3, 'o')
%        plot(i_peak4+360, a_peak4, 'o')
       piezo_echo_peaks(i, :)=[a_peak1, a_peak2, a_peak3, a_peak4];
       piezo_echo_peaks_index(i,:)=[i_peak1+120, i_peak2+200, i_peak3+280, i_peak4+360];
       
%       pause(0.1);
    end
    
    
    
%     write_to_file=true;%%%%Creat a text file with name: "sound_caracter_ + filename" containing the results of the algorithm if true.
%     
    delay_time=zeros(1,size(v,1));
%     max_amp_echo1=zeros(1,size(v,1));
%     max_amp_echo2=zeros(1,size(v,1));
    %max_frq=zeros(1,size(v,1));
    max_frq_amp=zeros(1,size(v,1));
    signal_var=zeros(size(v,1),1);
    signal_var_strt_rmv=zeros(size(v,1),1);
    N = 3500;
    power_spectrum=zeros(size(v,1),N/2+1);
% 
    remove_start_noise_index=700; %Remove all values in front of this index.
%     v(:,1:remove_start_noise_index)=zeros(size(v,1),remove_start_noise_index);
% 
    number_of_measurements=size(v,1); %Number of measurements in the file beeing threated.
% 
    h=waitbar(0,'Please wait..');%%%%Creates a waitbar to show the progress of the program.
% 
% 
    period_length=14; %% Number of samples in a period. 14 because signalfrequency 1MHz and sampling frequency 14 MHz.
% 
% 
    echo1_padding=10*period_length;
    echo2_padding=10*period_length;
    echo1=zeros(size(v,1), 5*echo1_padding+1);
    echo2=zeros(size(v,1), 5*echo2_padding+1);
% 
    %%%%Loops trough all the measurements and detects the roundtrip time.
    for i=1:number_of_measurements,
% 

%         
%         %%%%%Size of the window used to look for echo1
        size_window1=800;
        %%%%%Index where the echo1 window begins
        t1=700;
% 
        %%%%%Create a vector containing the energy in the signal in a given
        %%%%%window
        wave_energy_echo1=signal_energy_window(v(i,t1:t1+size_window1-1), 2*period_length);
%         %%%%%Remove all non-peaks, mainly to improve runtime.
%         wave_energy_peaks_echo1=filterOutNonPeaks(wave_energy_echo1);
%     %     [echo_strength_echo1, echo_index_echo1]=max(wave_energy_peaks_echo1);
        %Find the index of the maximum in the echo1 window. This should be
        %somwhere within echo1.
        [echo_strength_echo1, echo_index_echo1]=max(wave_energy_echo1);
        %Find the start of echo1 based on a dynamic threshold value
        [ start_echo1, ~ ] = echoStartAndEndIndex(wave_energy_echo1, echo_index_echo1);
% 
% 
% 
% 
        %%%%%Size of the window used to look for echo2
        size_window2=size_window1;
        %%%%%Index where the echo2 window begins. This depends on where the
        %%%%%start of echo2 was found.
        t2=2*(t1+start_echo1)-round(size_window2/2);
        %%%%%Create a vector containing the energy in the signal in a given
        %%%%%window
        wave_energy_echo2=signal_energy_window(v(i,t2:t2+size_window2-1), 2*period_length);
%         %%%%%Remove all non-peaks, mainly to improve runtime.
%         wave_energy_peaks_echo2=filterOutNonPeaks(wave_energy_echo2);
        %%%%%Find max value in the echo 2 window. Here a gaussian window is
        %%%%%used to favorise the area we expect the echo to occure based on
        %%%%%the previous detection of echo1.
        [~, echo_index_echo2]=max(wave_energy_echo2.*gausswin(size_window2)');
%     %     echo_strength_echo2=wave_energy_peaks_echo2(echo_index_echo2);
        %Find the start of echo2 based on a dynamic threshold value
        [ start_echo2, ~ ] = echoStartAndEndIndex(wave_energy_echo2, echo_index_echo2);
%         
        %%%%%Add som area around the start of each echo.
        end_echo1=t1+start_echo1+4*echo1_padding;
        end_echo2=t2+start_echo2+4*echo2_padding;
       
        
        start_echo1=t1+start_echo1-echo1_padding;
        start_echo2=t2+start_echo2-echo2_padding;
        if end_echo2>length(v(i,:)),
            end_echo2=length(v(i,:));
            start_echo2=end_echo2 -5*echo2_padding;
        end 


        %%%%%Store the window used to compare echo1 and echo2 in two vectors.
        echo1(i, :)=v(i,start_echo1:end_echo1);
        echo2(i, :)=v(i,start_echo2:end_echo2);
        
        
        
        signal_var(i)=var(v(i,:));
        v_strt_rmv=v(i,:);
        v_strt_rmv(1:remove_start_noise_index)=zeros(1,remove_start_noise_index);    
        signal_var_strt_rmv(i)=var(v_strt_rmv(remove_start_noise_index+1:end));
        xdft = fft(v_strt_rmv(1:N));
        xdft = xdft(1:N/2+1);
        psdx = (1/(Fs*N)).*abs(xdft).^2;
        psdx(2:end-1) = 2*psdx(2:end-1);
        [max_frq_amp(i), ~]=max(psdx);
        power_spectrum(i,:)=psdx;
%        [max_frq_amp(i), max_frq(i)]=max(psdx);
% 
        %%%%%Detect the index shift corresponding to the best fit between echo1
        %%%%%and echo2.
        %[~,index]=minerr(normalize(echo1(i, :)),normalize(echo2(i, :))); %normalizes the rest of the signal excluding echo 1 and compare echo 1 to it.

        %%%%%Use the index found with the first estimate of start echo1 and start echo2 to find the delay time. 
        %delay_time(i)=index+start_echo2-start_echo1;

        
%         figure(20)
%         subplot(2,1,1)
%         plot(v(i,:))
%         subplot(2,1,2)
%         plot(v_strt_rmv)
%         
        waitbar(i/number_of_measurements);


    end
    
%     figure(21)
%     subplot(2,1,1)
%     plot(signal_var)
%     subplot(2,1,2)
%     plot(signal_var_strt_rmv)
    
%     example=[example;v(i,1:3572)];
    close(h);

    [RTT, ~]=round_trip_time( v );

    
%     subplot(number_of_files_to_read,1,k)
%     plot(example(k,:))
%     figure(2)
%     subplot(number_of_files_to_read,1,k)
%     plot(psdx)
% %     figure(3)
% %     hold off
% %     plot(delay_time, 'b')
% %     axis([1,length(delay_time), min(delay_time)-5, max(delay_time)+5])
    max_amp_echo2=abs(max(echo2(:,:),[],2)-min(echo2(:,:),[],2))/2;
    max_amp_echo1=abs(max(echo1(:,:),[],2)-min(echo1(:,:),[],2))/2;
    damp_factor=damping_factor( echo1, echo2);
    [damp_factor_freq_echo1, damp_factor_freq_echo2]=damping_factor_freq( echo1, echo2);
    
    
    
    features_titles={['Temperature ', fluid_type], ...
                     ['Light intensity red (624 nm) ', fluid_type,  ', Ref\_value_{air}=1'], ...
                     ['Light intensity yellow/orange (605 nm) ', fluid_type,  ', Ref\_value_{air}=1'], ...
                     ['Light intensity yellow (589 nm) ', fluid_type,  ', Ref\_value_{air}=1'], ...
                     ['Light intensity green (573 nm) ', fluid_type,  ', Ref\_value_{air}=1'], ...
                     ['Light intensity blue/green (505 nm) ', fluid_type,  ', Ref\_value_{air}=1'], ...
                     ['Conductivity Pin 4 ', fluid_type ], ...
                     ['Conductivity Pin 3 ', fluid_type ], ...
                     ['Conductivity Pin 2 ', fluid_type ], ...
                     ['Startup noise peak strength Peak 1 , ', fluid_type], ...
                     ['Startup noise peak strength Peak 2 , ', fluid_type], ...
                     ['Startup noise peak strength Peak 3 , ', fluid_type], ...
                     ['Startup noise peak strength Peak 4 , ', fluid_type], ...
                     ['RTT ', fluid_type], ...
                     ['Max amplitude echo1 ', fluid_type], ...
                     ['Max amplitude echo2 ', fluid_type], ...
                     ['Damping factor between echo1 and echo2 ', fluid_type], ...
                     ['Max peak frequency spectrum ' ,fluid_type], ...
                     ['Factor between 1 MHz and 600KHz echo1 ', fluid_type], ...
                     ['Factor between 1 MHz and 600KHz echo2 ', fluid_type], ...
                     ['Signal variance ', fluid_type], ...
                     ['Signal variance after startup noise ', fluid_type]};
                 
    features_to_file=[volt_to_temp(temperature), ...
                     light.*(ones(size(light,1),1)*light_calibration), ...
                     conductivity, ...
                     piezo_echo_peaks, ...
                     (1000000*RTT/Fs)', ...
                     max_amp_echo1, ...
                     max_amp_echo2, ...
                     damp_factor, ...
                     max_frq_amp', ...
                     damp_factor_freq_echo1, ...
                     damp_factor_freq_echo2, ...
                     signal_var, ...
                     signal_var_strt_rmv];
    
    figure_index=1;
    figure(figure_index)
    figure_index=figure_index+1;
    h=plot_light(features_to_file(:,1), features_to_file(:, 2:6));
    %title: 'Light intensity ', fluid_type ', Ref\_value_{air}=1'
    title(['Light intensity ', fluid_type,  ', Ref\_value_{air}=1'])
    xlabel('Temperature [{\circ}C]')
    ylabel('Intensity')
    
    
    figure(figure_index)
    figure_index=figure_index+1;
    plot(features_to_file(:,1), features_to_file(:, 7:9), '*');
    %title: 'Conductivity ', fluid_type
    title(['Conductivity ', fluid_type ])
    xlabel('Temperature [{\circ}C]')
    ylabel('Volt')
    legend('pin 4', 'pin 3', 'pin 2')
    
    
    
    figure(figure_index)
    figure_index=figure_index+1;
    plot(features_to_file(:,1), features_to_file(:, 10:13), '*');
    ylabel('Peak strength')
    xlabel('Temperature [{\circ}C]')
    %title: 'Startup noise peak strength, ', fluid_type
    title(['Startup noise peak strength , ', fluid_type])
    legend('peak 1', 'peak 2', 'peak 3', 'peak 4')
    
    figure(figure_index)
    figure_index=figure_index+1;
    plot(features_to_file(:,1), features_to_file(:, 14))
    %title: 'RTT ', fluid_type
    title(features_titles{14})
    xlabel('Temperature [{\circ}C]')
    ylabel('Time [\mus]')
    
    figure(figure_index)
    figure_index=figure_index+1;
    plot(features_to_file(:,1), features_to_file(:, 15))
    %title: 'Max amplitude echo1 ', fluid_type
    title(features_titles{15})
    xlabel('Temperature [{\circ}C]')
    ylabel('Volt')
    
    figure(figure_index)
    figure_index=figure_index+1;
    plot(features_to_file(:,1), features_to_file(:, 16))
    %title: 'Max amplitude echo2 ', fluid_type
    title(features_titles{16})
    xlabel('Temperature [{\circ}C]')
    ylabel('Volt')
    
    figure(figure_index)
    figure_index=figure_index+1;
    plot(features_to_file(:,1), features_to_file(:, 17))
    %title: 'Damping factor between echo1 and echo2 ', fluid_type
    title(features_titles{17})
    xlabel('Temperature [{\circ}C]')
    ylabel('Scalar')
    
    figure(figure_index)
    figure_index=figure_index+1;
    plot(features_to_file(:,1), features_to_file(:, 18))
    %title: 'Max peak frequency spectrum ' , fluid_type
    title(features_titles{18})
    xlabel('Temperature [{\circ}C]')
    
    figure(figure_index)
    figure_index=figure_index+1;
    plot(features_to_file(:,1), features_to_file(:, 19))
    %title: 'Factor between 1 MHz and 600KHz echo1 ', fluid_type
    title(features_titles{19})
    xlabel('Temperature [{\circ}C]')
    
    figure(figure_index)
    figure_index=figure_index+1;
    plot(features_to_file(:,1), features_to_file(:, 20))
    %title: 'Factor between 1 MHz and 600KHz echo2 ', fluid_type
    title(features_titles{20})
    xlabel('Temperature [{\circ}C]')
    
    figure(figure_index)
    figure_index=figure_index+1;
    hold off
    plot(features_to_file(:,1), features_to_file(:, 21))
    %title: 'Signal energy ', fluid_type
    title(features_titles{21})
    xlabel('Temperature [{\circ}C]')
    ylabel('Variance')
    hold all
    plot(features_to_file(:,1), features_to_file(:, 22))
    legend('total variance', 'variance after startup noise')
    hold off

    features_titles={['Temperature ', fluid_type], ...
                     ['Light intensity red (624 nm) ', fluid_type,  ', Ref_value_{air}=1'], ...
                     ['Light intensity yellow/orange (605 nm) ', fluid_type,  ', Ref_value_{air}=1'], ...
                     ['Light intensity yellow (589 nm) ', fluid_type,  ', Ref_value_{air}=1'], ...
                     ['Light intensity green (573 nm) ', fluid_type,  ', Ref_value_{air}=1'], ...
                     ['Light intensity blue/green (505 nm) ', fluid_type,  ', Ref_value_{air}=1'], ...
                     ['Conductivity Pin 4 ', fluid_type ], ...
                     ['Conductivity Pin 3 ', fluid_type ], ...
                     ['Conductivity Pin 2 ', fluid_type ], ...
                     ['Startup noise peak strength Peak 1, ', fluid_type], ...
                     ['Startup noise peak strength Peak 2, ', fluid_type], ...
                     ['Startup noise peak strength Peak 3, ', fluid_type], ...
                     ['Startup noise peak strength Peak 4, ', fluid_type], ...
                     ['RTT ', fluid_type], ...
                     ['Max amplitude echo1 ', fluid_type], ...
                     ['Max amplitude echo2 ', fluid_type], ...
                     ['Damping factor between echo1 and echo2 ', fluid_type], ...
                     ['Max peak frequency spectrum ' ,fluid_type], ...
                     ['Factor between 1 MHz and 600KHz echo1 ', fluid_type], ...
                     ['Factor between 1 MHz and 600KHz echo2 ', fluid_type], ...
                     ['Signal variance ', fluid_type], ...
                     ['Signal variance after startup noise ', fluid_type]};
    
    if write_to_file,     
        if small_file,
            mkdir('smallfiles', fluid_type);
            filename_features=['smallfiles\', fluid_type , '\small_', filename, '_features', '.txt'];
            filename_feature_titles=['smallfiles\', fluid_type , '\small_', filename, '_feature_titles', '.txt'];
        else
            mkdir('labdata', fluid_type);
            filename_features=['labdata\', fluid_type , '\', filename, '_features', '.txt'];
            filename_feature_titles=['labdata\', fluid_type , '\', filename, '_feature_titles', '.txt'];
        end
        fid = fopen(filename_feature_titles, 'w');
        for i=1:length(features_titles),
            fprintf(fid, [features_titles{i}, '\n']);
        end
        dlmwrite(filename_features,features_to_file,'\t');
    end
end