function [ v ] = labinput( filename, average_window_size)
%LABINPUT labinput( filename, average_window_size). Imports a text file to
%a matrix. The textfile should only contain numbers of the format
%(-)x.something. In addition an average is calculated from
%"average_window_size" following row vectors in the matrix. This is done to
%improve the SNR of the signals. For this to make sense it is required that signals
%following eachother should be equivalent with some noise.
%   Detailed explanation goes here
    A = dlmread(filename);
    average_window=average_window_size; %Averaging over last average_window measures 

    v=zeros(size(A,1)-average_window+1,size(A,2));
    



    for i=1:size(A,2),
        v(1,i)=(sum(A(1:average_window,i))/average_window);%-offset;
    end

    for i=2:size(v,1),
        v(i,:)=(v(i-1,:)-(A(i-1, :)/average_window)+(A(i-1+average_window, :)/average_window));%-offset;
    end
    for i=1:size(v,1),
        v(i,:)=v(i,:)-mean(v(i,:));
    end
    
end

