function [ output ] = NclosNeighbor(x, Y, N)
%Finds N closest neightbors to x in the set Y and returns the most frequent
%class index of those neighbors. 
    min_distance=zeros(N,1);
    class_index=zeros(N,1);
    for i=1:N,
        min_distance(i)=norm(x-Y(i,2:end)');
        class_index(i)=Y(i,1);
    end
    [current_max, current_max_index]=max(min_distance);
    
    for i=4:size(Y,1),
        temp = norm(x-Y(i,2:end)');
        if temp<current_max,
            min_distance(current_max_index) = temp;
            class_index(current_max_index)=Y(i,1);
            [current_max, current_max_index]=max(min_distance);
        end
    end
    output= mode(class_index);
end

