clear all
class=1;

name_outputfile='dummy.txt';
name_classindexfile='class_indexes.txt';
name_parameterindexfile='parameter_index.txt';
parametername={};
% read_filename={
%     '..\smallfiles\adblue321\small_adblue321_all_11022014_features.txt', '..\smallfiles\adblue321\small_adblue321_all_11022014_feature_titles.txt', 'adblue321';
%     '..\smallfiles\adblue158\small_adblue158_all_12022014_features.txt', '..\smallfiles\adblue158\small_adblue158_all_12022014_feature_titles.txt', 'adblue158';
%     '..\smallfiles\diesel\small_diesel_all_14022014_features.txt', '..\smallfiles\diesel\small_diesel_all_14022014_feature_titles.txt', 'diesel';
%     '..\smallfiles\glycol100\small_glycol100_us_temp_cond_14032014_features.txt', '..\smallfiles\glycol100\small_glycol100_us_temp_cond_14032014_feature_titles.txt', 'glycol100';
%     '..\smallfiles\glycol50\small_glycol50_us_temp_cond_17032014_features.txt', '..\smallfiles\glycol50\small_glycol50_us_temp_cond_17032014_feature_titles.txt', 'glycol50';
%     '..\smallfiles\water\small_water_us_temp_cond_19032014_features.txt', '..\smallfiles\water\small_water_us_temp_cond_19032014_feature_titles.txt', 'water';
%     };
read_filename={
    '..\..\smallfiles\adblue321\small_2000adblue321_all_11022014_features.txt', '..\..\smallfiles\adblue321\small_adblue321_all_11022014_feature_titles.txt', 'adblue321';
    '..\..\smallfiles\adblue158\small_2000adblue158_all_12022014_features.txt', '..\..\smallfiles\adblue158\small_adblue158_all_12022014_feature_titles.txt', 'adblue158';
    '..\..\smallfiles\diesel\small_2000diesel_all_14022014_features.txt', '..\..\smallfiles\diesel\small_diesel_all_14022014_feature_titles.txt', 'diesel';
    '..\..\smallfiles\glycol100\small_2000glycol100_us_temp_cond_14032014_features.txt', '..\..\smallfiles\glycol100\small_glycol100_us_temp_cond_14032014_feature_titles.txt', 'glycol100';
    '..\..\smallfiles\glycol50\small_2000glycol50_us_temp_cond_17032014_features.txt', '..\..\smallfiles\glycol50\small_glycol50_us_temp_cond_17032014_feature_titles.txt', 'glycol50';
    '..\..\smallfiles\water\small_2000water_us_temp_cond_19032014_features.txt', '..\..\smallfiles\water\small_water_us_temp_cond_19032014_feature_titles.txt', 'water';
    };


%%%feature set per class===================================================
X_class=cell(size(read_filename,1),1);
classname=cell(size(read_filename,1),1);

feature_list={};
fid = fopen(read_filename{1,2}, 'rt');
tline = fgetl(fid);
feature_list_index=1;
while ischar(tline)
    feature_list{feature_list_index}=tline;
    feature_list_index=feature_list_index+1;
    tline = fgetl(fid);
end

%Select features to be used================================================
feature_select=[1, 7:22];
temp_list=cell(size(feature_select));
for i=1:length(temp_list),
    temp_list{i}=feature_list{feature_select(i)};
end
feature_list={};
feature_list=temp_list;
fclose(fid);
%==========================================================================

%Display list of features==================================================
disp([int2str(1), ' class index'])
for i=1:length(feature_list),
    disp([int2str(i+1), ' ' ,feature_list{i}])
end
X=[];
for i=1:size(read_filename,1),
    %Load the set of feature vectors into X
    temp=dlmread(read_filename{i,1});
    temp=temp(:,feature_select);
    X=[X;class*ones(size(temp,1),1), temp];
    classname{class}=read_filename{i,3};
    disp([int2str(class), ': ', classname{class}])
    class=class+1;
end
%==========================================================================

%%%Remove all samples with RTT values outside the valid area. <50 and >90==
I=X(:,10)>=50;
X=X(I,:);
I=X(:,10)<=90;
X=X(I,:);
%==========================================================================

%%%Remove all samples with signalvariance<0.001============================
I=X(:,17)>=0.001;
X=X(I,:);
%==========================================================================



%%%Remove all samples with temperatures outside the valid area. <min_temp
%%%and >max_temp===========================================================
min_temp=-0;
max_temp=40;
I=X(:,2)>=min_temp;
X=X(I,:);
I=X(:,2)<=max_temp;
X=X(I,:);
%==========================================================================

%Scale the feature set. Scalevector coefficients have been found manually=?
scale_vector=[1, 10, 10, 10, 10, 10, 10, 10, 1, 10, 10, 10, 1e7, 1, 1, 100, 100];
X(:,2:end)=X(:,2:end)*diag(scale_vector);
%==========================================================================

%Divide feature set into training end test set=============================
%%Every other feature vector is added to the test set X_test, and the rest 
%is kept in the trainingset X==============================================
X_test=X(2:2:size(X,1),:);
X=X(1:2:size(X,1),:);
%==========================================================================


%%Sort feature vectors by class for easy classwise access================== 
for i=1:size(X,1),
    class_index=X(i,1);
    X_class{class_index}=[X_class{class_index};X(i,:)];
end
%==========================================================================

% %Find the min and max temp value covered by all classes====================
% min_temp=-inf;
% max_temp=inf;
% for i=1:size(X_class,1),
%     if size(X_class{i},1)>0,
%         min_temp=max(min_temp, min(X_class{i}(:,2)));
%         max_temp=min(max_temp, max(X_class{i}(:,2)));
%     end
% end
% %==========================================================================
% 
% %%%Remove all samples with temperatures outside the valid area. <min_temp
% %%%and >max_temp===========================================================
% I=X(:,2)>=min_temp;
% X=X(I,:);
% I=X(:,2)<=max_temp;
% X=X(I,:);
% 
% for i=1:size(X_class,1),
%     if size(X_class{i},1)>0,
%         I=X_class{i}(:,2)>=min_temp;
%         X_class{i}=X_class{i}(I,:);
%         I=X_class{i}(:,2)<=max_temp;
%         X_class{i}=X_class{i}(I,:);
%     end
% end
% 
% %==========================================================================

%Derive within class scatter matrix S_W and between class scatter matrix
%S_B=======================================================================
featuresX=[2:size(X_class{1},2)];

n_i=zeros(size(X_class,1),1);
m_i=zeros(size(X_class,1),length(featuresX));
m=0;

S_W=zeros(length(featuresX), length(featuresX));
S_B=zeros(length(featuresX), length(featuresX));
for i=1:size(X_class,1),
   n_i(i)=size(X_class{i}(:,featuresX),1);
   m_i(i,:)=(1/n_i(i))*sum(X_class{i}(:,featuresX));
   for j=1:size(X_class{i}(:,featuresX),1),
       S_W=S_W+(X_class{i}(j,featuresX)-m_i(i))'*(X_class{i}(j,featuresX)-m_i(i));
   end
   m=m+n_i(i)*m_i(i,:);
end
m=(1/sum(n_i))*m;
for i=1:size(X_class,1),
    S_B=S_B+(n_i(i)*(m_i(i,:)-m)'*(m_i(i,:)-m));
end
%==========================================================================

%Define characteristic polynomial==========================================
syms lambda;
[p,~]=coeffs(det(S_B-lambda*S_W));
p=double(p); %convert to numeric
lambda=roots(p);

%
W=zeros(length(featuresX),size(X_class,1)-1);
for i=1:size(X_class,1)-1,
    W(:,i)=null((S_B-lambda(i)*S_W),zeros(size(S_B,1),1));
end





%%Transform the feature set X to the new set Y=============================
Y_class=cell(size(X_class,1),1);
Y_train=[];
for i=1:size(X_class,1),
    Y_class{i}=[X_class{i}(:,1),(W'*X_class{i}(:,featuresX)')'];
    Y_train=[Y_train;Y_class{i}];
end

Y_test=[X_test(:,1),(W'*X_test(:,featuresX)')'];

%==========================================================================

% 
% %Plot the new feature set in two 3d plots==================================
% figure(1)
% clf
% hold all
% for i=1:size(X_class,1),
%     plot3(Y_class{i}(:,2), Y_class{i}(:,3), Y_class{i}(:,4), '*')
% end
% legend(classname)
% figure(2)
% clf
% hold all
% for i=1:size(X_class,1),
%     plot3(Y_class{i}(:,2), Y_class{i}(:,5), Y_class{i}(:,6), '*')
% end
% legend(classname)
% 
% 
% %==========================================================================
%==========================================================================

featuresY=[2:size(Y_class{1},2)];
Pclas=1/size(Y_class,1);
max_number_of_feaures=inf;
min_number_of_feaures=-inf;
k_neigbors=40;
%features=[10];

if max_number_of_feaures<1,
    disp('max_number_of_feaures less than 1')
else
%%%%Create a waitbar to show the progress of the program===================
h=waitbar(0,'Please wait..');
%==========================================================================

total_number_of_iterations=0;
for dim_number=max(1,min_number_of_feaures):min(length(featuresY),max_number_of_feaures),
    total_number_of_iterations=total_number_of_iterations+nchoosek(length(featuresY),dim_number);
end
current_iteration=0;

%systematic test all combinations of features==============================
filename_syst_test_output=['syst_test_results_', num2str(k_neigbors), 'NN_mda',strrep(strrep(strrep(datestr(now), '-', '_'), ':', '_'), ' ', '_') , '.txt'];
P_error_min=inf*ones(length(featuresY),1);
P_error_max=zeros(length(featuresY),1);
featurecombination_min_err=cell(length(featuresY),1);
C_min=zeros(size(Y_class,1),size(Y_class,1),length(featuresY));
Y_class_parameters=cell(size(Y_class,1),1);


for dim_number=max(1,min_number_of_feaures):min(length(featuresY),max_number_of_feaures),
    %Find all permutation of features given number of features (dim_number)
    %to be used============================================================
    feature_combination_matrix=nchoosek(featuresY, dim_number);
    %======================================================================
    for permutation_number=1:size(feature_combination_matrix,1),
        
        current_iteration=current_iteration+1;
        waitbar(current_iteration/total_number_of_iterations, h,[int2str(current_iteration), ' of ', int2str(total_number_of_iterations)]);
        features_used=feature_combination_matrix(permutation_number,:);
        
        c=zeros(size(Y_class_parameters,1));

        for i=1:size(Y_test,1),
                classification_index=NclosNeighbor(Y_test(i,features_used)', Y_train(:,[1,features_used]), k_neigbors);
                c(Y_test(i,1),classification_index)=c(Y_test(i,1),classification_index)+1; 
        end

        P_error=sum(sum(c.*(ones(size(Y_class_parameters,1))-eye(size(Y_class_parameters,1)))))/sum(sum(c));

        %Oppdaterer P_error_min og X_min===================================
        if P_error<=P_error_min(dim_number)
            P_error_min(dim_number)=P_error;
            featurecombination_min_err{dim_number}=features_used;
            C_min(:,:,dim_number)=c;
        end
        %==================================================================
        
        %Oppdaterer P_error_max============================================
        if P_error>=P_error_max(dim_number)
            P_error_max(dim_number)=P_error;
        end
        %==================================================================
        

    end

        fid = fopen(filename_syst_test_output, 'a');
        temp_string=['===================================='];
        fprintf(fid, [temp_string, '\n']);
        disp(temp_string)
        for i=1:length(featurecombination_min_err{dim_number}),
            temp_string=['Feature: ', num2str(featurecombination_min_err{dim_number}(i)-1)];
            disp(temp_string)
            fprintf(fid, [temp_string, '\n']);
        end
        for i=1:size(C_min(:,:,dim_number),1),
            for j=1:size(C_min(:,:,dim_number),2),
                temp_string= num2str(C_min(i,j,dim_number));
                fprintf(fid, [temp_string, '\t']);
            end
            fprintf(fid, ['\n']);
        end
        disp(C_min(:,:,dim_number))
        
        temp_string= ['P_error: ', num2str(P_error_min(dim_number))];
        disp(temp_string)
        fprintf(fid, [temp_string, '\n']);
        temp_string=['===================================='];
        fprintf(fid, [temp_string, '\n']);
        disp(temp_string)
        fclose(fid);
end

close(h);
end