clear all
class=1;

name_outputfile='dummy.txt';
name_classindexfile='class_indexes.txt';
name_parameterindexfile='parameter_index.txt';
parametername={};
read_filename={
    '..\smallfiles\adblue321\small_adblue321_all_11022014_features.txt', '..\smallfiles\adblue321\small_adblue321_all_11022014_feature_titles.txt', 'adblue321';
    '..\smallfiles\adblue158\small_adblue158_all_12022014_features.txt', '..\smallfiles\adblue158\small_adblue158_all_12022014_feature_titles.txt', 'adblue158';
    '..\smallfiles\diesel\small_diesel_all_14022014_features.txt', '..\smallfiles\diesel\small_diesel_all_14022014_feature_titles.txt', 'diesel';
    %'..\smallfiles\saltwater135gl\small_saltwater135gl_us_temp_cond_18032014_features.txt', '..\smallfiles\saltwater135gl\small_saltwater135gl_us_temp_cond_18032014_feature_titles.txt', 'saltwater135gl';
    '..\smallfiles\glycol100\small_glycol100_us_temp_cond_14032014_features.txt', '..\smallfiles\glycol100\small_glycol100_us_temp_cond_14032014_feature_titles.txt', 'glycol100';
    '..\smallfiles\glycol50\small_glycol50_us_temp_cond_17032014_features.txt', '..\smallfiles\glycol50\small_glycol50_us_temp_cond_17032014_feature_titles.txt', 'glycol50';
    '..\smallfiles\water\small_water_us_temp_cond_19032014_features.txt', '..\smallfiles\water\small_water_us_temp_cond_19032014_feature_titles.txt', 'water';
    };


%%%feature set per class
X_class=cell(size(read_filename,1),1);
classname=cell(size(read_filename,1),1);

feature_list={};
fid = fopen(read_filename{1,2}, 'rt');
tline = fgetl(fid);
feature_list_index=1;
while ischar(tline)
    feature_list{feature_list_index}=tline;
    %disp(tline)
    feature_list_index=feature_list_index+1;
    tline = fgetl(fid);
end

feature_select=[1, 7:22];
temp_list=cell(size(feature_select));
for i=1:length(temp_list),
    temp_list{i}=feature_list{feature_select(i)};
end
feature_list={};
feature_list=temp_list;


fclose(fid);
disp([int2str(1), ' class index'])
for i=1:length(feature_list),
    disp([int2str(i+1), ' ' ,feature_list{i}])
end
X=[];
for i=1:size(read_filename,1),
    %Load the set of feature vectors into X
    temp=dlmread(read_filename{i,1});
    temp=temp(:,feature_select);
    X=[X;class*ones(size(temp,1),1), temp];
    classname{class}=read_filename{i,3};
    disp([int2str(class), ': ', classname{class}])
    class=class+1;
end

% figure(22)
% clf
% hold all
% plot(X(:,17))
% plot(X(:,18))

% figure(3)
% plot(X(:,2), X(:,15),'*')
% xlabel('Temperature')
% ylabel('RTT [\mus]')
% title('RTT as a function of temperature, all classes included')

%%%Remove all samples with RTT values outside the valid area. <50 and >90
I=X(:,10)>=50;
X=X(I,:);
I=X(:,10)<=90;
X=X(I,:);

%%%Remove all samples with signal variance<0.001
I=X(:,17)>=0.001;
X=X(I,:);

poly_coeff=dlmread('polynom_coeff_with_marczak.txt');
%X(:,10)=X(:,10)-SOUND_VELOCITY_CUSTOM_POLYNOM(poly_coeff(X(:,1),:), X(:,2));


X_test=X;
% figure(11)
% clf
% hold all
% subplot(1,2,1)
% plot(X(:,10))
% title('Detected RTT for all classes')
% ylabel('RTT [\mus]')
% axis([0,length(X(:,10)), 55, 90])
for i=1:size(X(:,10)),
    X(i,10)=X(i,10)-1e6*(0.109/SOUND_VELOCITY_CUSTOM_POLYNOM(poly_coeff(X(i,1),:), X(i,2)));
end

% subplot(1,2,2)
% plot(X(:,10))
% title('Detected RTT subtracted by assumed true RTT')
% ylabel('RTT_{detected}-RTT_{true} [\mus]')
% axis([0,length(X(:,10)), -6, 12])


scale_vector=[1, 10, 10, 10, 10, 10, 10, 10, 1, 10, 10, 10, 1e7, 1, 1, 100, 100];
X(:,2:end)=X(:,2:end)*diag(scale_vector);
X_test(:,2:end)=X_test(:,2:end)*diag(scale_vector);
% figure(10)
% clf
% hold all
%disp('	& min:				&	max: 				\\\hline')
for i=1:length(feature_list),
    
%     plot(X(:,i+1))
    %disp([feature_list{i}, ' & ' , num2str(min(X(:,i+1))) , ' & ', num2str(max(X(:,i+1))), '\\\hline'])
end


%%Sort feature vectors by class for easy classwise access 
for i=1:size(X,1),
    class_index=X(i,1);
    X_class{class_index}=[X_class{class_index};X(i,:)];
end


% 
% 
% hold off
% figure(1)
% plot(X(:,22), X(:,15),'*')
% xlabel('Signal variance')
% ylabel('RTT [\mus]')
% title('RTT as a function of signal variance, all classes included')
% 
% figure(2)
% plot(X(:,2), X(:,15),'*')
% xlabel('Temperature')
% ylabel('RTT [\mus]')
% title('RTT as a function of temperature, all classes included')
% figure(4)
% clf
% hold all
min_temp=-inf;
max_temp=inf;
for i=1:size(X_class,1),
    if size(X_class{i},1)>0,
        min_temp=max(min_temp, min(X_class{i}(:,2)));
        max_temp=min(max_temp, max(X_class{i}(:,2)));
%         plot(X_class{i}(:,2), X_class{i}(:,10),'*');    
        %plot( X_class{i}(:,15));    
    end
end
% plot([min_temp, min_temp], [min(X(:,10)), max(X(:,10))])
% plot([max_temp, max_temp], [min(X(:,10)), max(X(:,10))])
% xlabel('Temperature')
% ylabel('RTT [\mus]')
% title('RTT as a function of temperature, all classes included')
% legend(classname)

%%%Remove all samples with temperatures outside the valid area. <min_temp
%%%and >max_temp
I=X(:,2)>=min_temp;
X=X(I,:);
I=X(:,2)<=max_temp;
X=X(I,:);



% figure(4)
% clf
% hold all
for i=1:size(X_class,1),
    if size(X_class{i},1)>0,
        I=X_class{i}(:,2)>=min_temp;
        X_class{i}=X_class{i}(I,:);
        I=X_class{i}(:,2)<=max_temp;
        X_class{i}=X_class{i}(I,:);
        %plot(X_class{i}(:,2), X_class{i}(:,10),'*');    
        %plot( X_class{i}(:,15));    
    end
end
% xlabel('Temperature')
% ylabel('RTT [\mus]')
% title('RTT as a function of temperature, all classes included')
% legend(classname)

% figure(5)
% clf
% hold all
% %%Remove outliers using Chauvenet's criterion
% for i=1:size(X_class,1),
%     if size(X_class{i},1)>0,
%         %plot(X_class{i}(:,2), X_class{i}(:,15),'*');
%         temp_resolution=5;
%         temp_min=floor(min(X_class{i}(:,2)));
%         temp_max=floor(max(X_class{i}(:,2)));
%         temp=temp_min:temp_resolution:temp_max;
%         RTT=cell(length(temp),1);
%         RTT_mean=zeros(size(RTT));
%         RTT_var=zeros(size(RTT));
%         %%Group observations into according to nearest integer temperature
%         %%level
%         for j=1:length(X_class{i}(:,15)),
%             temp_index=floor((X_class{i}(j,2)-min(X_class{i}(:,2)))/temp_resolution)+1;
%             RTT{temp_index}=[RTT{temp_index}; X_class{i}(j,15)]; 
%         end
%         for j=1:length(RTT_mean),
%             RTT_mean(j)=mean(RTT{j});
%             RTT_var(j)=var(RTT{j});
%         end
%         plot(temp+temp_resolution/2, RTT_mean);
%         plot(temp+temp_resolution/2, RTT_mean+RTT_var, ':');
%         plot(temp+temp_resolution/2, RTT_mean-RTT_var, ':');
%         
%     end
% end
% figure(4)
% clf
% hold all
% for i=1:size(X_class,1),
%     if size(X_class{i},1)>0,
%         plot(X_class{i}(:,22), X_class{i}(:,11),'*');    
%         %plot( X_class{i}(:,15));    
%     end
% end
% xlabel('Temperature')
% ylabel('Damping factor between echo1 and echo2')
% title('Damping factor as a function of temperature, all classes included')
% legend(classname)

%%Sort feature set in chungs with same temperature

% X_class_temp=cell(size(X_class));
% figure(7)
% clf
% hold on
% for i=1:size(X_class,1),
%     if size(X_class{i},1)>0,
%         %plot(X_class{i}(:,2), X_class{i}(:,15),'*');
%         temp_resolution=2;
%         temp_min=floor(min(X_class{i}(:,2)));
%         temp_max=floor(max(X_class{i}(:,2)));
%         temp=temp_min:temp_resolution:temp_max;
%         X_temp=cell(length(temp),1);
%         %%Group observations into according to nearest integer temperature
%         %%level
%         for j=1:length(X_class{i}(:,10)),
%             temp_index=floor((X_class{i}(j,2)-min(X_class{i}(:,2)))/temp_resolution)+1;
%             X_temp{temp_index}=[X_temp{temp_index}; X_class{i}(j,:)]; 
%         end
%         X_class_temp{i}=X_temp;
%         %disp('temp length: ')
%         %disp(length(X_class{i}))
%         for j=1:length(X_class_temp{i}),
%             if size(X_class_temp{i}{j},1)>0,
% %                 plot(X_class{i}{j}(:,2), X_class{i}{j}(:,10), 'o');
%                 plot(temp_resolution*j, X_class_temp{i}{j}(:,10), 'o');
%             end
%         end
%     end
% end
% 
% 
% 
% %%%Find normal distribution parameters for all classes and temperatures:
% 
% Pclas=1/size(X_class_temp,1);
% 
% 
% size_singular_set=[];
% size_non_singular_set=[];
% number_with_zero_variance=0;
% for i=1:size(X_class_temp,1),
%     for j=1:length(X_class_temp{i}),
%         if size(X_class_temp{i}{j},1)>1,
%             mu=mean(X_class_temp{i}{j}(:,2:end));
%             sigma=sqrt(var( X_class_temp{i}{j}(:,2:end)));
%             if sum(1*(sigma==0))>0,
%                 number_with_zero_variance=number_with_zero_variance+1;
%             end
%             %sigma=sigma+0.1*rand(size(sigma));
%             coMat=cov(X_class_temp{i}{j}(:,2:end));
%             %disp(det(coMat))
%             if 0==det(coMat),
%                 size_singular_set=[size_singular_set, size(X_class_temp{i}{j},1)];
%             else
%                 size_non_singular_set=[size_non_singular_set, size(X_class_temp{i}{j},1)];
%             end
% %             w0=-0.5*(mu/coMat)*mu'-0.5*log(det(coMat))+log(Pclas);
% %             w_=coMat\mu';
% %             W=-0.5*inv(coMat);
% %             X_class{i}{j}={W,w_, w0, X_class{i}{j}};
%         end
%     end
% end


Pclas=1/size(X_class,1);
features=[3:size(X_class{1},2)];
max_number_of_feaures=inf;
%features=[10];

%%%%Create a waitbar to show the progress of the program===================
h=waitbar(0,'Please wait..');
%==========================================================================

total_number_of_iterations=0;
for dim_number=1:min(length(features),max_number_of_feaures),
    total_number_of_iterations=total_number_of_iterations+nchoosek(length(features),dim_number);
end
current_iteration=0;




%systematic test all combinations of features==============================
filename_syst_test_output=['syst_test_results_min_err',strrep(strrep(strrep(datestr(now), '-', '_'), ':', '_'), ' ', '_') , '.txt'];
P_error_min=inf*ones(length(features),1);
P_error_max=zeros(length(features),1);
featurecombination_min_err=cell(length(features),1);
C_min=zeros(size(X_class,1),size(X_class,1),length(features));
X_class_parameters=cell(size(X_class,1),1);


for dim_number=1:min(length(features),max_number_of_feaures),
    %Find all permutation of features given number of features (dim_number)
    %to be used============================================================
    feature_combination_matrix=nchoosek(features, dim_number);
    %======================================================================
    for permutation_number=1:size(feature_combination_matrix,1),
        current_iteration=current_iteration+1;
        waitbar(current_iteration/total_number_of_iterations, h,[int2str(current_iteration), ' of ', int2str(total_number_of_iterations)]);
        features_used=feature_combination_matrix(permutation_number,:);
        min_sigma=0.5;

        size_singular_set=[];
        size_non_singular_set=[];
        number_with_zero_variance=0;
        for i=1:size(X_class,1),
            
            
            if size(X_class{i},1)>1,
                %%mu equals the mean for all features except for the RTT as this is
                %%a function of temperature  (defined by poly_coeff expected(RTT)=1e6*(0.109/SOUND_VELOCITY_CUSTOM_POLYNOM(poly_coeff(X(i,1),:), X(i,2))))
                expected_RTT=@(t,class_index) 1e6*(0.109./SOUND_VELOCITY_CUSTOM_POLYNOM(poly_coeff(class_index,:), t));
                if length(features_used)==1 & features_used(1)==10,
                    mu=@(t) [expected_RTT(t,i)];
                else
                    mu=mean(X_class{i});
                    function_index=find(features_used==10);
                    if isempty(function_index),
                        mu=@(t) [mu(features_used)'];
                    elseif function_index==1,
                        mu=@(t) [expected_RTT(t,i); mu(features_used(function_index+1:end))'];
                    elseif function_index==length(features_used),
                        mu=@(t) [mu(features_used(1:function_index-1))'; expected_RTT(t,i)];
                    else
                        mu=@(t) [mu(features_used(1:function_index-1))'; expected_RTT(t,i); mu(features_used(function_index+1:end))'];
                    end

                end
                sigma=sqrt(var( X_class{i}(:,features_used)));
                if sum(1*(sigma==0))>0,
                    number_with_zero_variance=number_with_zero_variance+1;
                end
                %sigma=sigma+0.1*rand(size(sigma));
                coMat=cov(X_class{i}(:,features_used));
                for j=1:size(coMat,1),
                    coMat(j,j)=max([coMat(j,j),min_sigma^2]);
                end
                %disp(det(coMat))
                if 0==det(coMat),
                    size_singular_set=[size_singular_set, size(X_class{i},1)];
                else
                    size_non_singular_set=[size_non_singular_set, size(X_class{i},1)];
                end
                w0=@(t) -0.5*(mu(t)'/coMat)*mu(t)-0.5*log(det(coMat))+log(Pclas);
                w_=@(t) coMat\mu(t);
                W=-0.5*inv(coMat);
                X_class_parameters{i}={W,w_, w0,mu,coMat, X_class{i}};
            end

        end
        %%%%Plots==================================================================
        % figure(1)
        % clf
        % hold all
        % t=min_temp:max_temp;
        % x=zeros(size(t));
        % for i=1:size(X_class,1),    
        %     for j=1:length(x),
        %         temp=X_class{i}{4}(j);
        %         x(j)=temp(8);
        %     end
        %     plot(x);
        % end
        % 
        % min_sigma=0.5;
        % 
        % t=min_temp:0.1:max_temp;
        % x=50:0.1:90;
        % y=zeros(length(x), length(t), size(X_class,1));
        % for k=1:size(X_class,1),    
        %     for i=1:size(y,1),
        %         for j=1:size(y,2),
        %             mu1=X_class{k}{4}(t(j));
        %             y(i,j,k)=normpdf(x(i),mu1(8), max(min_sigma,sqrt(X_class{k}{5}(8,8))));
        %         end
        %     end
        % end
        % 
        % figure(2)
        % h=surf(t,x,max(y,[],3));
        % xlabel('temperature [\circC]')
        % ylabel('RTT [\mus]')
        % title('p(RTT|temperature)')
        % set(h,'LineStyle','none')
        % axis([0,40, 50, 90, 0, 3])
        %==========================================================================

        c=zeros(size(X_class_parameters,1));
        %test_features_used=[3:size(X_class{1},2)];

        for i=1:size(X_test,1),

                [classification_value, classification_index]=g_minimum_error_rate( X_test(i,features_used)', X_class_parameters, X_test(i,2));
                c(X_test(i,1),classification_index)=c(X_test(i,1),classification_index)+1; 
        end
%         disp('====================================')
%         disp(['Feature(s): ', num2str(features_used), ': ',feature_list{features_used-1}(1:end-10)])
%         disp(c)
        P_error=sum(sum(c.*(ones(size(X_class_parameters,1))-eye(size(X_class_parameters,1)))))/sum(sum(c));
%         disp(['P_error: ', num2str(P_error)])
%         disp('====================================')
        %Oppdaterer P_error_min og X_min===================================
        if P_error<=P_error_min(dim_number)
            P_error_min(dim_number)=P_error;
            featurecombination_min_err{dim_number}=features_used;
            C_min(:,:,dim_number)=c;
        end
        %==================================================================
        
        %Oppdaterer P_error_max============================================
        if P_error>=P_error_max(dim_number)
            P_error_max(dim_number)=P_error;
        end
        %==================================================================
        
        % for i=1:size(X_class,1),    
        %     disp(cov(X_class{i}(:,features_used)))
        %     disp(rank(cov(X_class{i}(:,features_used))))
        %     disp(eig(cov(X_class{i}(:,features_used))))
        % end
    end

        fid = fopen(filename_syst_test_output, 'a');
        temp_string=['===================================='];
        fprintf(fid, [temp_string, '\n']);
        disp(temp_string)
        for i=1:length(featurecombination_min_err{dim_number}),
            temp_string=['Feature(s): ', num2str(featurecombination_min_err{dim_number}(i)), ': ',feature_list{featurecombination_min_err{dim_number}(i)-1}(1:end-10)];
            disp(temp_string)
            fprintf(fid, [temp_string, '\n']);
        end
        for i=1:size(C_min(:,:,dim_number),1),
            for j=1:size(C_min(:,:,dim_number),2),
                temp_string= num2str(C_min(i,j,dim_number));
                fprintf(fid, [temp_string, '\t']);
            end
            fprintf(fid, ['\n']);
        end
        disp(C_min(:,:,dim_number))
        
        temp_string= ['P_error: ', num2str(P_error_min(dim_number))];
        disp(temp_string)
        fprintf(fid, [temp_string, '\n']);
        temp_string=['===================================='];
        fprintf(fid, [temp_string, '\n']);
        disp(temp_string)
        fclose(fid);
end

close(h);