clear all

%Filenames of the rawdata files to read from
%read_filename={'vann_us_temp_cond_03022014'};
% read_filename={'adblue321_all_11022014'};
% light_sensor_calibration={'11022014calib_light_sensor'};
% read_filename={'adblue158_all_12022014'};
% light_sensor_calibration={'12022014calib_light_sensor'};
% read_filename={'saltwater135gl_all_13022014'};
% light_sensor_calibration={'13022014calib_light_sensor'};

figure_index=1;
%read_filename={'saltwater135gl_all_13022014', 'adblue321_all_11022014','adblue158_all_12022014',  'diesel_all_14022014'};
read_filename={'vann_us_temp_cond_03022014'};

number_of_files_to_read=length(read_filename);



for k=1:number_of_files_to_read,
	filename=read_filename{k};
    
    
    disp(filename)
    filename_arduino=[filename, '_light_cond_temp', '.txt'];
    filename_us=[filename, '_us', '.txt'];
    
    v=labinput(['labdata\',filename_us],1);
    arduino=dlmread(['labdata\',filename_arduino]);
    
    number_of_measurements=size(v,1);
    
    
    length_of_new_file=1000;
    jump_size=floor(number_of_measurements/length_of_new_file);
    
    v_new=zeros(length_of_new_file, size(v,2));
    arduino_new=zeros(length_of_new_file, size(arduino,2));
    
    for i=1:length_of_new_file,
        v_new(i,:)=v(1+(i-1)*jump_size,:);
        arduino_new(i,:)=arduino(1+(i-1)*jump_size,:);
    end

    dlmwrite(['labdata\small_',filename_us],v_new,'\t');
    dlmwrite(['labdata\small_',filename_arduino],arduino_new,'\t');

end